<div class="items-list mb-5">

  <div class="container">

    <h1 class="mat-h1">Wyposażenie</h1>
    <mat-divider class="mb-2"></mat-divider>

    <mat-card>
      <div class="search-div">
        <ng-container *ngIf="currentUser?.permissions?.canEditItems">
          <button mat-raised-button (click)="onCreateItemDialog()">
            <mat-icon>add</mat-icon>
            Dodaj wyposażenie
          </button>
        </ng-container>
        <mat-form-field class="search-form-field">
          <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj przedmiot" autocomplete="off"
                 (keyup)="applyFilter()">
          <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
            <mat-icon>close</mat-icon>
          </button>
        </mat-form-field>
      </div>

      <div class="mat-elevation-z8">
        <mat-table [dataSource]="itemsDataSource" matSort>

          <ng-container matColumnDef="name">
            <mat-header-cell *matHeaderCellDef>Nazwa przedmiotu</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.name}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="department">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Dział</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.department?.name}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="employee">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Pracownik</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.employee?.data?.firstName}} {{element?.employee?.data?.lastName}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="description">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Opis</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.description}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="warrantyEndDate">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Data końca gwarancji</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.warrantyEndDate | date: 'd/MM/yyyy'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="typeOfOwnership">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Rodzaj posiadania</mat-header-cell>
            <mat-cell *matCellDef="let element">
              <ng-container *ngIf="element?.typeOfOwnership === 'own'">
                Na własność
              </ng-container>
              <ng-container *ngIf="element?.typeOfOwnership === 'leasing'">
                Leasingowany
              </ng-container>
              <ng-container *ngIf="element?.typeOfOwnership === 'loan'">
                Wypożyczony
              </ng-container>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="actions">
            <mat-header-cell *matHeaderCellDef></mat-header-cell>
            <mat-cell *matCellDef="let row">
              <ng-container *ngIf="currentUser?.permissions?.canEditItems">
                <button mat-icon-button (click)="onUpdateItemDialog(row)">
                  <mat-icon matTooltip="Edytuj wpis wyposażenia">edit</mat-icon>
                </button>
                <button mat-icon-button color="warn" (click)="onRemoveItem(row)">
                  <mat-icon matTooltip="Usuń wpis wyposażenia">delete_outline</mat-icon>
                </button>
              </ng-container>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="loading">
            <mat-footer-cell *matFooterCellDef>
              Ładowanie danych...
            </mat-footer-cell>
          </ng-container>
          <ng-container matColumnDef="noData">
            <mat-footer-cell *matFooterCellDef>
              Aktualnie brak danych o wyposażenie w Twojej firmie.
            </mat-footer-cell>
          </ng-container>

          <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
          <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

          <mat-footer-row *matFooterRowDef="['loading']"
                          [ngClass]="{'none':itemsDataSource!=null}"></mat-footer-row>
          <mat-footer-row *matFooterRowDef="['noData']"
                          [ngClass]="{'none':!(itemsDataSource!=null && itemsDataSource.data.length==0)}"></mat-footer-row>

        </mat-table>
        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>
      </div>
    </mat-card>

  </div>
</div>
